package org.jboss.demo.sessionsharing;

import java.io.Serializable;

/**
 * Serialized data object that is stored in a session context, with an attempt at sharing 
 * across contexts.
 *
 */
public class SerializedData implements Serializable {
	
	String name = "Serialized Data Object";
	String number = "12345";
	static final long serialVersionUID = 1;
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getNumber() {
		return number;
	}
	
	public void setNumber(String number) {
		this.number = number;
	}
	
	public String toString()
	{
		return this.name + " - " + this.number;
	}
	
	public boolean equals(SerializedData obj)
	{
		if (this.getName().equals(obj.getName()) && this.getNumber().equals(obj.getNumber()))
			return true;
		else
			return false;		
	}
	
	public int hashCode()
	{
		return (this.getName().hashCode() + this.getNumber().hashCode() * 29);
	}	
}
