/*
 * JBoss Open Source Federation
 * The Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.demo.sessionsharing;

import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.ServletContext;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class SharePutDataAction extends Action {

	/**
	 * Put a cookie string, a sessionid cookie string and a data object into the session context.
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		HttpSession session = request.getSession();
		
		//store a simple string cookie
		String sessionid = session.getId();
								
		//store an object in one context				
		storeDataInContext(this.getServlet().getServletContext(), sessionid, new SerializedData());			
				
		return mapping.findForward("SUCCESS");
		
	}
	
	/**
	 * 
	 * utility method to store an object in the servlet context.
	 * 
	 * @param context
	 * @param sessionid
	 * @param data
	 */
	private synchronized void storeDataInContext(ServletContext context,
			String sessionid, Object data) {		

		//load the shared_userroles from the context
	    Hashtable shareddata = (Hashtable)context.getAttribute("shared_data");

	    // if not yet available, create a new one
	    if (shareddata==null) {
	        shareddata = new Hashtable();
	    }

	    // store the userroles of the current session
	    shareddata.put(sessionid, data);

	    // store the shareddata back into the Context
		context.setAttribute("shared_data", shareddata);
		System.out.println("I SET THE DATA OBJ TO: " + data);
	}
	
}
